/*
 * led_rotation.c
 *
 *  Created on: 14/mar/2016
 *      Author: fb
 */

#include "config.h"

/* delay generation */
#define CYCLES_PER_MS 254 /* hand tuned to achieve around 1 ms resolution (code optimization OFF)*/
void Wait_ms(unsigned int time_ms) {
	int i,j;
	for(j=0; j<time_ms; j++) {
		for(i=0; i<CYCLES_PER_MS; i++) {;}
	}
}

/* FSM led control */

uint8_t led_control(uint32_t keys) {
	static enum {LEFT, RIGHT, STOPPED} rot_stat = STOPPED;
	static uint8_t led_stat = 0;

	if(keys & BIT(KEY_STOP)) {
		rot_stat = STOPPED;
	}
	else if(keys & BIT(KEY_LEFT)) {
		rot_stat = LEFT;
	}
		else if(keys & BIT(KEY_RIGHT)) {
			rot_stat = RIGHT;
		}

	switch (rot_stat) {
		case LEFT:
			led_stat = led_stat << 1;
			if(!led_stat) {
				led_stat = BIT(LED_LEFT_ON);
			}
			break;
		case RIGHT:
			led_stat = led_stat >> 1;
			if(!led_stat) {
				led_stat = BIT(LED_RIGHT_ON);
			}
			break;
	}
	return led_stat;
}



int main() {
	KEYS_EDGE_CAPTURE_REG = 0XF;
	while(1) {

		GREEN_LEDS_REG = led_control(KEYS_EDGE_CAPTURE_REG);
		KEYS_EDGE_CAPTURE_REG = 0XF;
		Wait_ms(ROT_PERIOD);
	}

}

